"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const anchor_1 = require("@coral-xyz/anchor");
const web3_js_1 = require("@solana/web3.js");
const fs_1 = __importDefault(require("fs"));
const client_1 = require("../../src/client");
const constants_1 = require("../../src/constants");
async function main() {
    try {
        const options = anchor_1.AnchorProvider.defaultOptions();
        const connection = new web3_js_1.Connection(process.env.CLUSTER_URL, options);
        const user = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(fs_1.default.readFileSync(process.env.USER_KEYPAIR, 'utf-8'))));
        const userWallet = new anchor_1.Wallet(user);
        const userProvider = new anchor_1.AnchorProvider(connection, userWallet, options);
        //
        // mainnet
        //
        // const client = await MangoClient.connect(
        //   userProvider,
        //   'mainnet-beta',
        //   MANGO_V4_ID['mainnet-beta'],
        //   {
        //     idsSource: 'get-program-accounts',
        //   },
        // );
        // const group = await client.getGroup(
        //   new PublicKey('78b8f4cGCwmZ9ysPFMWLaLTkkaYnUjwMJYStWe5RTSSX'),
        // );
        // console.log(
        //   await client.getMangoAccountForOwner(
        //     group,
        //     new PublicKey('v3mmtZ8JjXkaAbRRMBiNsjJF1rnN3qsMQqRLMk7Nz2C'),
        //     3,
        //   ),
        // );
        // console.log(
        //   await client.getMangoAccountsForDelegate(
        //     group,
        //     new PublicKey('5P9rHX22jb3MDq46VgeaHZ2TxQDKezPxsxNX3MaXyHwT'),
        //   ),
        // );
        //
        // devnet
        //
        const client = await client_1.MangoClient.connect(userProvider, 'devnet', constants_1.MANGO_V4_ID['devnet'], {
            idsSource: 'get-program-accounts',
        });
        const admin = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(fs_1.default.readFileSync(process.env.ADMIN_KEYPAIR, 'utf-8'))));
        const group = await client.getGroupForCreator(admin.publicKey, 37);
        let mangoAccount = (await client.getMangoAccountForOwner(group, user.publicKey, 0));
        let sig;
        // let sig = await client.accountExpandV2(
        //   group,
        //   mangoAccount,
        //   16,
        //   8,
        //   8,
        //   32,
        //   8,
        // );
        console.log(sig);
        // sig = await client.tokenConditionalSwapStopLoss(
        //   group,
        //   mangoAccount,
        //   group.getFirstBankByTokenIndex(0 as TokenIndex).mint,
        //   group.getFirstBankByTokenIndex(1 as TokenIndex).mint,
        //   1,
        //   null,
        //   25,
        //   24,
        //   1,
        // );
        // console.log(sig);
        mangoAccount = (await client.getMangoAccountForOwner(group, user.publicKey, 0));
        console.log(mangoAccount.tokenConditionalSwaps[2].toString(group));
    }
    catch (error) {
        console.log(error);
    }
}
main();
